clang-tools 8.0.0

Classes | Functions
clang::find_all_symbols Namespace Reference

## Classes
class | FindAllMacros
| A preprocessor that collects all macro symbols. More...
class | FindAllSymbols
| FindAllSymbols collects all classes, free standing functions and global variables with some extra information such as the path of the header file, the namespaces they are contained in, the type of variables and the parameter types of functions. More...
class | FindAllSymbolsAction
class | FindAllSymbolsActionFactory
class | HeaderMapCollector
| HeaderMappCollector collects all remapping header files. More...
class | PragmaCommentHandler
| PragmaCommentHandler parses pragma comment on include files to determine when we should include a different header from the header that directly defines a symbol. More...
struct | SymbolAndSignals
class | SymbolInfo
| Describes a named symbol from a header. More...
class | SymbolReporter
| An interface for classes that collect symbols. More...
class | YamlReporter

## Functions
std::string | getIncludePath (const SourceManager &SM, SourceLocation Loc, const HeaderMapCollector *Collector=nullptr)
| This calculates the include path for `Loc`. More...
const HeaderMapCollector::RegexHeaderMap * | getSTLPostfixHeaderMap ()
bool | WriteSymbolInfosToStream (llvm::raw_ostream &OS, const SymbolInfo::SignalMap &Symbols)
| Write SymbolInfos to a stream (YAML format). More...
std::vector< SymbolAndSignals > | ReadSymbolInfosFromYAML (llvm::StringRef Yaml)
| Read SymbolInfos from a YAML document. More...
bool | Merge (llvm::StringRef MergeDir, llvm::StringRef OutputFile)

## Function Documentation

## ◆ getIncludePath()

std::string clang::find_all_symbols::getIncludePath | ( | const SourceManager & | SM,
|  | SourceLocation | Loc,
|  | const HeaderMapCollector * | Collector = `nullptr`
| ) |  |

This calculates the include path for `Loc`.

Parameters

  SM | SourceManager.
  Loc | A SourceLocation.
  Collector | An optional header mapping collector.

Returns
  The file path (or mapped file path if Collector is provided) of the header that includes `Loc`. If `Loc` comes from .inc header file, `Loc` is set to the location from which the .inc header file is included. If `Loc` is invalid or comes from a main file, this returns an empty string.

Definition at line 17 of file PathConfig.cpp.

## ◆ getSTLPostfixHeaderMap()

const HeaderMapCollector::RegexHeaderMap * clang::find_all_symbols::getSTLPostfixHeaderMap | ( |  | ) |

Definition at line 15 of file STLPostfixHeaderMap.cpp.

Referenced by main().

## ◆ Merge()

bool clang::find_all_symbols::Merge | ( | llvm::StringRef | MergeDir,
|  | llvm::StringRef | OutputFile
| ) |  |

Definition at line 77 of file FindAllSymbolsMain.cpp.

References Merge().

Referenced by main(), and Merge().

## ◆ ReadSymbolInfosFromYAML()

std::vector< SymbolAndSignals > clang::find_all_symbols::ReadSymbolInfosFromYAML | ( | llvm::StringRef | Yaml | ) |

Read SymbolInfos from a YAML document.

Definition at line 129 of file SymbolInfo.cpp.

Referenced by clang::include_fixer::YamlSymbolIndex::createFromFile(), and clang::include_fixer::FuzzySymbolIndex::createFromYAML().

## ◆ WriteSymbolInfosToStream()

bool clang::find_all_symbols::WriteSymbolInfosToStream | ( | llvm::raw_ostream & | OS,
|  | const SymbolInfo::SignalMap & | Symbols
| ) |  |

Write SymbolInfos to a stream (YAML format).

Definition at line 119 of file SymbolInfo.cpp.